const request = require('request-promise-native');
const execFileSync = require('child_process').execFileSync;
const http = require('http');
const fs = require('fs');

const apiToken = ''

const waitForMS = (ms) => new Promise(resolve => setTimeout(resolve, ms));

const os = ["lin", "mac", "win", "win", "win", "win", "android"]
const random = Math.floor(Math.random() * os.length);

async function createProfile() {
    const options = {
        'method': 'POST',
        'url': 'https://mmo4me.com/threads/chia-se-cac-buoc-tao-profile-gologin-su-dung-offline.449942/post-7721301',
        'headers': {
            'Authorization': 'Bearer ' + apiToken,
            'Content-Type': 'application/json'
        },
        body: JSON.stringify({
            "name": "New_name",
            "browserType": "chrome",
            "os": os[random],
            "notes": "",
            "startUrl": "https://gologin.app",
            "googleServicesEnabled": false,
            "navigator": {
                "userAgent": "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/110.0.5481.77 Safari/537.36",
                "resolution": "1366x768",
                "language": "en-US,en",
                "platform": "Win32"
            },
            "proxy": {
                "mode": "none",
            },
            "timezone": {
                "enabled": true,
                "fillBasedOnIp": true,
                "timezone": "Asia/Bangkok"
            },
            "geolocation": {
                "mode": "prompt",
                "enabled": true,
                "customize": true,
                "fillBasedOnIp": true
            },
            "audioContext": {
                "mode": "off"
            },
            "canvas": {
                "mode": "off"
            },
            "fonts": {
                "families": [
                    "string"
                ],
                "enableMasking": true,
                "enableDomRect": true
            },
            "mediaDevices": {
                "videoInputs": 0,
                "audioInputs": 0,
                "audioOutputs": 0,
                "enableMasking": false
            },
            "webRTC": {
                "mode": "alerted",
                "enabled": true,
                "customize": true,
                "localIpMasking": false,
                "fillBasedOnIp": true,
                // "publicIp": "string",
                // "localIps": [
                //     "string"
                // ]
            },
            "webGL": {
                "mode": "noise"
            },
            "clientRects": {
                "mode": "noise"
            },
            "webGLMetadata": {
                "mode": "mask",
                "vendor": "ANGLE (Google, Vulkan 1.3.0 (SwiftShader Device (Subzero) (0x0000C0DE)), SwiftShader driver)",
                "renderer": "Google Inc. (Google)"
            },
            "webglParams": [],
            "googleClientId": "",
            "chromeExtensions": [],
            "folders": []
        })
    };

    return request(options).then((response) => {
        // console.log(response);
        return JSON.parse(response).id;
    });
}

async function openProfile(profileId) {
    const options = {
        'method': 'POST',
        'url': 'http://localhost:36912/browser/start-profile',
        'headers': {
            'Content-Type': 'application/json'
        },
        body: JSON.stringify({
            profileId,
            "sync": false
        })
    };

    return request(options).then(response => {
        console.log(response);
    })
}

async function downloadProfile(profileId) {
    const options = {
        'method': 'GET',
        'url': 'https://api.gologin.com/browser/' + profileId,
        'headers': {
            'Authorization': 'Bearer ' + apiToken
        }
    };

    return request(options).then(response => {
        console.log(response);
        // console.log(JSON.parse(response.body).s3Path);
        console.log(`HTTP://S3.EU-CENTRAL-1.AMAZONAWS.COM/gprofiles.gologin/${JSON.parse(response).s3Path}`);

        const file = fs.createWriteStream(profileId + ".zip");
        http.get(`HTTP://S3.EU-CENTRAL-1.AMAZONAWS.COM/gprofiles.gologin/${JSON.parse(response).s3Path}`, function (response) {
            response.pipe(file);
        });
    });
}

async function deleteProfile(profileId) {
    const options = {
        'method': 'DELETE',
        'url': 'https://api.gologin.com/browser/' + profileId,
        'headers': {
            'Authorization': 'Bearer ' + apiToken,
        }
    };

    return request(options).then(response => {
        console.log(response);
    });
}

(async () => {
    console.log("Create profile");
    const profileId = await createProfile();
    console.log(profileId);
    console.log("Open profile");
    await openProfile(profileId);
    await waitForMS(3000);
    execFileSync('closeOrbita.exe');
    await waitForMS(5000);
    console.log("Download profile");
    await downloadProfile(profileId);
    console.log("Delete profile");
    await deleteProfile(profileId);
})();
